/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao;

import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.Tarifa;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.TarifaService;

import java.util.List;

import org.zkoss.web.fn.ServletFns;

/**
 * 
 * @author rodrigo
 */
public interface TarifaDAO extends GenericDAO<Tarifa, Integer> {

	public List<Tarifa> pesquisar(Marca marca, Parada origem, Parada destino, Moneda moneda,ClaseServicio claseServicio, VigenciaTarifa vigenciaTarifa,Categoria categoria, TipoPuntoVenta tipoPuntoVenta);

	/**
	 * {@link TarifaService#existe(Marca, Tramo, Moneda, ClaseServicio, VigenciaTarifa, Ruta, OrgaoConcedente)}
	 * 
	 * @param marca
	 * @param tramo
	 * @param moneda
	 * @param claseServicio
	 * @param vigenciaTarifa
	 * @param ruta
	 * @param orgaoConcedente
	 * @return
	 */
	public boolean existe(Marca marca, Tramo tramo, Moneda moneda, ClaseServicio claseServicio, VigenciaTarifa vigenciaTarifa, Ruta ruta, OrgaoConcedente orgaoConcedente);
	
	public Tarifa buscar(Tramo tramo, Marca marca, ClaseServicio claseServicio,VigenciaTarifa vigenciaTarifa, Moneda moneda, Ruta ruta);

	/**
	 * Lista as tarifas que tem a vigencia informada.<br/>
	 * 
	 * As tarifas listadas podem estar ativas ou inativas<br/>
	 * 
	 * @param vigencia
	 * @return
	 */
	public List<Tarifa> buscarTarifasAtivasInativasPorVigencia(VigenciaTarifa vigencia);

	/**
	 * 	Lista as tarifas que tem a vigencia informada.<br/>
	 * 
	 *  S  listado as tarifas ativas<br/>
	 *  
	 * @param vigenciaTarifa
	 * @return
	 */
	public List<Tarifa> buscarTarifasAtivasPorVigencia(VigenciaTarifa vigenciaTarifa);
	
	public boolean buscarTarifaExisteTramo(Tramo tramo) ;
}
