/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.EstacionDAO;
import com.rjconsultores.ventaboletos.entidad.Estacion;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 * 
 * @author Administrador
 */
@Repository("estacionDAO")
public class EstacionHibernateDAO extends GenericHibernateDAO<Estacion, Integer> implements EstacionDAO {

	@Autowired
	public EstacionHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<Estacion> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("activo", Boolean.TRUE));
		c.addOrder(Order.asc("descestacion"));

		return c.list();
	}

	public List<Estacion> buscar(String descEstacion, String descMac, Long nunCaja, PuntoVenta pv) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("activo", Boolean.TRUE));

		c.add(Restrictions.eq("descestacion", descEstacion));
		c.add(Restrictions.eq("descmac", descMac));
		c.add(Restrictions.eq("numcaja", nunCaja));
		c.add(Restrictions.eq("puntoVenta", pv));

		return c.list();
	}

	public List<Estacion> buscar(String descMac) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("activo", Boolean.TRUE));
		c.add(Restrictions.eq("descmac", descMac));

		return c.list();
	}

	@Override
	public List<Estacion> buscar(Long numCaja, PuntoVenta puntoVenta) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("activo", Boolean.TRUE));
		c.add(Restrictions.eq("numcaja", numCaja));
		c.add(Restrictions.eq("puntoVenta", puntoVenta));

		return c.list();
	}
}
