/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.MarcaDAO;
import com.rjconsultores.ventaboletos.entidad.Marca;

/**
 *
 * @author Administrador
 */
@Repository("marcaDAO")
public class MarcaHibernateDAO extends GenericHibernateDAO<Marca, Short>
        implements MarcaDAO {

    @Autowired
    public MarcaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<Marca> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("descmarca"));

        return c.list();
    }

    public List<Marca> buscarPorNome(String nomeMarca) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("descmarca", nomeMarca));

        return c.list();
    }

    public List<Marca> buscarTodosExceto(Integer... idMarca) {
        Criteria c = this.makeCriteria();
        for (Integer id : idMarca) {
            c.add(Restrictions.ne("marcaId", id.shortValue()));
        }
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("descmarca"));
        return c.list();

    }

	@Override
	public List<Marca> buscarDescricaoIdMarca() {
		String hql = " select new com.rjconsultores.ventaboletos.entidad.Marca(m.marcaId, m.descmarca) from Marca m where m.marcaId <> -1 ";
		Query sq = getSession().createQuery(hql);
		List<Marca> lsMarca = sq.list();
		return lsMarca;
	}

}
