package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.PtovtaBancoDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaBanco;

@Repository("ptovtaBancoDAO")
public class PtovtaBancoHibernateDAO extends GenericHibernateDAO<PtovtaBanco, Integer>
	implements PtovtaBancoDAO {

    @Autowired
    public PtovtaBancoHibernateDAO(
            @Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<PtovtaBanco> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("nome"));
        
        return c.list();
    }

    public List<PtovtaBanco> buscar(String nome) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("nome", nome));
        

        return c.list();
    }

   
}

