package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.PtovtaPercentualDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaPercentual;



@Repository("ptovtaPercentualDAO")
public class PtovtaPercentualHibernateDAO extends GenericHibernateDAO<PtovtaPercentual, Integer>
	implements PtovtaPercentualDAO {

    @Autowired
    public PtovtaPercentualHibernateDAO(
            @Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<PtovtaPercentual> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("id"));
        
        return c.list();
    }

    public List<PtovtaPercentual> buscar(int id) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("id", id));
        

        return c.list();
    }

   
}

