/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.RolOperativoDAO;
import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.entidad.RolOperativo;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("rolOperativoDAO")
public class RolOperativoHibernateDAO extends GenericHibernateDAO<RolOperativo, Integer>
        implements RolOperativoDAO {

    @Autowired
    public RolOperativoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<RolOperativo> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        return c.list();
    }

    public List<RolOperativo> pesquisar(DiagramaAutobus diagrama, String rol) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        if (diagrama != null) {
            c.add(Restrictions.eq("diagramaAutobus", diagrama));
        }
        if (rol != null) {
            c.add(Restrictions.eq("descroloperativo", rol));
        }
        return c.list();
    }

    public List<RolOperativo> buscar(String descroloperativo) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("descroloperativo", descroloperativo));

        return c.list();
    }
}
