/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.TipoPuntoVentaDAO;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("tipoPuntoVentaDAO")
public class TipoPuntoVentaHibernateDAO extends GenericHibernateDAO<TipoPuntoVenta, Short>
        implements TipoPuntoVentaDAO {

    @Autowired
    public TipoPuntoVentaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<TipoPuntoVenta> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("desctipo"));

        return c.list();
    }

    public List<TipoPuntoVenta> buscar(String desctipo) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("desctipo", desctipo));

        return c.list();
    }
}
