/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "AUTOBUS_SEQ", sequenceName = "AUTOBUS_SEQ", allocationSize = 1)
@Table(name = "AUTOBUS")
public class Autobus implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "AUTOBUS_ID")
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "AUTOBUS_SEQ")
    private Integer autobusId;
    @Column(name = "NUMAUTOBUS")
    private String numautobus;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "DIAGRAMAAUTOBUS_ID", referencedColumnName = "DIAGRAMAAUTOBUS_ID")
    @ManyToOne
    private DiagramaAutobus diagramaAutobus;
    @JoinColumn(name = "DIAGRAMAAUTOBUS2_ID", referencedColumnName = "DIAGRAMAAUTOBUS_ID")
    @ManyToOne
    private DiagramaAutobus diagramaAutobusPiso;
    @OneToMany(mappedBy = "autobus")
    private List<Corrida> corridaList;

    public Autobus() {
    }

    public Autobus(Integer autobusId) {
        this.autobusId = autobusId;
    }

    public Integer getAutobusId() {
        return autobusId;
    }

    public void setAutobusId(Integer autobusId) {
        this.autobusId = autobusId;
    }

    public String getNumautobus() {
        return numautobus;
    }

    public void setNumautobus(String numautobus) {
        this.numautobus = numautobus;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public DiagramaAutobus getDiagramaAutobus() {
        return diagramaAutobus;
    }

    public void setDiagramaAutobus(DiagramaAutobus diagramaAutobus) {
        this.diagramaAutobus = diagramaAutobus;
    }

    public List<Corrida> getCorridaList() {
        return corridaList;
    }

    public void setCorridaList(List<Corrida> corridaList) {
        this.corridaList = corridaList;
    }

    public DiagramaAutobus getDiagramaAutobusPiso() {
        return diagramaAutobusPiso;
    }

    public void setDiagramaAutobusPiso(DiagramaAutobus diagramaAutobusPiso) {
        this.diagramaAutobusPiso = diagramaAutobusPiso;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (autobusId != null ? autobusId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Autobus)) {
            return false;
        }
        Autobus other = (Autobus) object;
        if ((this.autobusId == null && other.autobusId != null) || (this.autobusId != null && !this.autobusId.equals(other.autobusId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return getNumautobus();
    }
}
