/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "CATEGORIA_CTRL_SEQ", sequenceName = "CATEGORIA_CTRL_SEQ", allocationSize = 1)
@Table(name = "CATEGORIA_CTRL")
public class CategoriaCtrl implements Serializable {

    public final static Integer[] idsCategoriasNoVisible = {1};
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "CATEGORIA_CTRL_SEQ")
    @Column(name = "CATEGORIACTRL_ID")
    private Integer categoriactrlId;
    @JoinColumn(name = "EMPRESA_ID")
    @OneToOne
    private Empresa empresa;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Basic(optional = false)
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToMany(mappedBy = "categoriaCtrl", cascade = CascadeType.ALL)
    private List<CategoriaDescuento> categoriaDescuentoList;
    @OneToMany(mappedBy = "categoriaCtrl", cascade = CascadeType.ALL)
    private List<CategoriaClase> categoriaClaseList;
    @OneToMany(mappedBy = "categoriaCtrl", cascade = CascadeType.ALL)
    private List<CategoriaMarca> categoriaMarcaList;
    @OneToMany(mappedBy = "categoriaCtrl", cascade = CascadeType.ALL)
    private List<CategoriaCorrida> categoriaCorridaList;
    @OneToMany(mappedBy = "categoriaCtrl", cascade = CascadeType.ALL)
    private List<CategoriaMercado> categoriaMercadoList;

    public CategoriaCtrl() {
    }

    public CategoriaCtrl(Integer categoriactrlId) {
        this.categoriactrlId = categoriactrlId;
    }

    public CategoriaCtrl(Integer categoriactrlId, Date fecmodif) {
        this.categoriactrlId = categoriactrlId;
        this.fecmodif = fecmodif;
    }

    public Integer getCategoriactrlId() {
        return categoriactrlId;
    }

    public void setCategoriactrlId(Integer categoriactrlId) {
        this.categoriactrlId = categoriactrlId;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    /**
     * Regresa las categorias que son visibles al usuario.
     * Ejemplo de categoria que no es visible: ADULTO - Id = 1
     * @return 
     */
    public List<CategoriaDescuento> getCategoriaDescuentoVisiblesList() {
        List<CategoriaDescuento> listCategoriasVisibles = new ArrayList<CategoriaDescuento>();
        List<CategoriaDescuento> lsCategorias = getCategoriaDescuentoList();

        for (CategoriaDescuento cd : lsCategorias) {
            boolean esVisible = true;
            for (Integer id : idsCategoriasNoVisible) {
            	if(cd.getCategoria()!=null){
            		if (id.equals(cd.getCategoria().getCategoriaId())) {
            			esVisible = false;
            		}
            	}
            }
            
            if (esVisible) {
                listCategoriasVisibles.add(cd);
            }
        }
        
        return listCategoriasVisibles;
    }

    public List<CategoriaDescuento> getCategoriaDescuentoList() {
        //return categoriaDescuentoList;

        List<CategoriaDescuento> tmp = new ArrayList<CategoriaDescuento>();
        if (categoriaDescuentoList != null) {
            for (CategoriaDescuento cm : this.categoriaDescuentoList) {
                if (cm.getActivo()) {
                    tmp.add(cm);
                }
            }
        }

        return tmp;
    }

    public void setCategoriaDescuentoList(List<CategoriaDescuento> categoriaDescuentoList) {
        this.categoriaDescuentoList = categoriaDescuentoList;
    }

    public List<CategoriaClase> getCategoriaClaseList() {
        //return categoriaClaseList;
        List<CategoriaClase> tmp = new ArrayList<CategoriaClase>();
        if (categoriaClaseList != null) {
            for (CategoriaClase cm : this.categoriaClaseList) {
                if (cm.getActivo()) {
                    tmp.add(cm);
                }
            }
        }

        return tmp;
    }

    public void setCategoriaClaseList(List<CategoriaClase> categoriaClaseList) {
        this.categoriaClaseList = categoriaClaseList;
    }

    public List<CategoriaMarca> getCategoriaMarcaList() {
        //return categoriaMarcaList;
        List<CategoriaMarca> tmp = new ArrayList<CategoriaMarca>();
        if (categoriaMercadoList != null) {
            for (CategoriaMarca cm : this.categoriaMarcaList) {
                if (cm.getActivo()) {
                    tmp.add(cm);
                }
            }
        }

        return tmp;
    }

    public void setCategoriaMarcaList(List<CategoriaMarca> categoriaMarcaList) {
        this.categoriaMarcaList = categoriaMarcaList;
    }

    public List<CategoriaCorrida> getCategoriaCorridaList() {
        //return categoriaCorridaList;
        List<CategoriaCorrida> tmp = new ArrayList<CategoriaCorrida>();
        if (categoriaCorridaList != null) {
            for (CategoriaCorrida cm : this.categoriaCorridaList) {
                if (cm.getActivo()) {
                    tmp.add(cm);
                }
            }
        }

        return tmp;
    }

    public void setCategoriaCorridaList(List<CategoriaCorrida> categoriaCorridaList) {
        this.categoriaCorridaList = categoriaCorridaList;
    }

    public List<CategoriaMercado> getCategoriaMercadoList() {
        List<CategoriaMercado> tmp = new ArrayList<CategoriaMercado>();
        if (categoriaMercadoList != null) {
            for (CategoriaMercado cm : this.categoriaMercadoList) {
                if (cm.getActivo()) {
                    tmp.add(cm);
                }
            }
        }

        return tmp;
    }

    public void setCategoriaMercadoList(List<CategoriaMercado> categoriaMercadoList) {
        this.categoriaMercadoList = categoriaMercadoList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (categoriactrlId != null ? categoriactrlId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CategoriaCtrl)) {
            return false;
        }
        CategoriaCtrl other = (CategoriaCtrl) object;
        if ((this.categoriactrlId == null && other.categoriactrlId != null) || (this.categoriactrlId != null && !this.categoriactrlId.equals(other.categoriactrlId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.CategoriaCtrl[categoriactrlId=" + categoriactrlId + "]";
    }
}
