/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * 
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "ESQUEMA_CORRIDA_SEQ", sequenceName = "ESQUEMA_CORRIDA_SEQ", allocationSize = 1)
@Table(name = "ESQUEMA_CORRIDA")
public class EsquemaCorrida implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "ESQUEMACORRIDA_ID")
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "ESQUEMA_CORRIDA_SEQ")
    private Integer esquemacorridaId;
    @Column(name = "HORASALIDA")
    @Temporal(TemporalType.TIME)
    private Date horasalida;
    @Column(name = "INDPISOEXTRA")
    private Boolean pisoExtra;
    @Column(name = "INDLUNES")
    private Boolean indlunes;
    @Column(name = "INDMARTES")
    private Boolean indmartes;
    @Column(name = "INDMIERCOLES")
    private Boolean indmiercoles;
    @Column(name = "INDJUEVES")
    private Boolean indjueves;
    @Column(name = "INDVIERNES")
    private Boolean indviernes;
    @Column(name = "INDSABADO")
    private Boolean indsabado;
    @Column(name = "INDDOMINGO")
    private Boolean inddomingo;
    @Column(name = "CANTPARADOS")
    private Integer cantparados;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @Column(name = "DIAGRAMAAUTOBUS_ID")
    private Integer diagramaAutobusId;
    @Column(name = "STATUSCORRIDA")
    private String statusCorrida;
    @JoinColumn(name = "RUTA_ID", referencedColumnName = "RUTA_ID")
    @ManyToOne
    private Ruta ruta;
    @JoinColumn(name = "ROLOPERATIVO_ID", referencedColumnName = "ROLOPERATIVO_ID")
    @ManyToOne(cascade = CascadeType.ALL)
    private RolOperativo rolOperativo;
    @JoinColumn(name = "ROLOPERATIVO2_ID", referencedColumnName = "ROLOPERATIVO_ID")
    @ManyToOne(cascade = CascadeType.ALL)
    private RolOperativo rolOperativo2;
    @JoinColumn(name = "MARCA_ID", referencedColumnName = "MARCA_ID")
    @ManyToOne
    private Marca marca;
    @JoinColumn(name = "ESQUEMAOPERACIONAL_ID", referencedColumnName = "ESQUEMAOPERACIONAL_ID")
    @ManyToOne(cascade = CascadeType.ALL)
    private EsquemaOperacional esquemaOperacional;
    @JoinColumn(name = "EMPRESACORRIDA_ID", referencedColumnName = "EMPRESA_ID")
    @ManyToOne
    private Empresa empresa;
    @JoinColumn(name = "EMPRESAINGRESO_ID", referencedColumnName = "EMPRESA_ID")
    @ManyToOne
    private Empresa empresa1;
    @JoinColumn(name = "CLASESERVICIO_ID", referencedColumnName = "CLASESERVICIO_ID")
    @ManyToOne
    private ClaseServicio claseServicio;
    @JoinColumn(name = "CLASESERVICIO2_ID", referencedColumnName = "CLASESERVICIO_ID")
    @ManyToOne
    private ClaseServicio claseServicio2;
    @OneToMany(cascade = CascadeType.ALL)
    @JoinColumn(name = "ESQUEMACORRIDA_ID", referencedColumnName = "ESQUEMACORRIDA_ID")
    private List<EsquemaTramo> esquemaTramoList;
    @OneToMany
    @JoinColumn(name = "ESQUEMACORRIDA_ID", referencedColumnName = "ESQUEMACORRIDA_ID")
    private List<EsquemaAsiento> esquemaAsientoList;
    @Column(name = "tipocorrida")
    private String tipocorrida;
    @JoinColumn(name = "ESQUEMAREBOTE_ID", referencedColumnName = "ESQUEMACORRIDA_ID")
    @ManyToOne
    private EsquemaCorrida esquemaCorridaRebote;
    @JoinColumn(name = "DIVISION_ID", referencedColumnName = "DIVISION_ID")
    @ManyToOne
    private Division division;
    @Column(name = "NUMCORRIDA")
    private Integer numCorrida;
    @Column(name = "NUMCORRIDAPISOEXTRA")
    private Integer numCorridaPisoExtra;

    public String getTipocorrida() {
        return tipocorrida;
    }

    public void setTipocorrida(String tipocorrida) {
        this.tipocorrida = tipocorrida;
    }

    public EsquemaCorrida() {
    }

    public EsquemaCorrida(Integer esquemacorridaId) {
        this.esquemacorridaId = esquemacorridaId;
    }

    public Integer getEsquemacorridaId() {
        return esquemacorridaId;
    }

    public void setEsquemacorridaId(Integer esquemacorridaId) {
        this.esquemacorridaId = esquemacorridaId;
    }

    public Date getHorasalida() {
        return horasalida;
    }

    public void setHorasalida(Date horasalida) {
        this.horasalida = horasalida;
    }

    public Integer getCantparados() {
        return cantparados;
    }

    public void setCantparados(Integer cantparados) {
        this.cantparados = cantparados;
    }

    public Boolean getInddomingo() {
        return inddomingo;
    }

    public void setInddomingo(Boolean inddomingo) {
        this.inddomingo = inddomingo;
    }

    public Boolean getIndjueves() {
        return indjueves;
    }

    public void setIndjueves(Boolean indjueves) {
        this.indjueves = indjueves;
    }

    public Boolean getIndlunes() {
        return indlunes;
    }

    public void setIndlunes(Boolean indlunes) {
        this.indlunes = indlunes;
    }

    public Boolean getIndmartes() {
        return indmartes;
    }

    public void setIndmartes(Boolean indmartes) {
        this.indmartes = indmartes;
    }

    public Boolean getIndmiercoles() {
        return indmiercoles;
    }

    public void setIndmiercoles(Boolean indmiercoles) {
        this.indmiercoles = indmiercoles;
    }

    public Boolean getIndsabado() {
        return indsabado;
    }

    public void setIndsabado(Boolean indsabado) {
        this.indsabado = indsabado;
    }

    public Boolean getIndviernes() {
        return indviernes;
    }

    public void setIndviernes(Boolean indviernes) {
        this.indviernes = indviernes;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Ruta getRuta() {
        return ruta;
    }

    public void setRuta(Ruta ruta) {
        this.ruta = ruta;
    }

    public RolOperativo getRolOperativo() {
        return rolOperativo;
    }

    public void setRolOperativo(RolOperativo rolOperativo) {
        this.rolOperativo = rolOperativo;
    }

    public Marca getMarca() {
        return marca;
    }

    public void setMarca(Marca marca) {
        this.marca = marca;
    }

    public EsquemaOperacional getEsquemaOperacional() {
        return esquemaOperacional;
    }

    public void setEsquemaOperacional(EsquemaOperacional esquemaOperacional) {
        this.esquemaOperacional = esquemaOperacional;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public Empresa getEmpresa1() {
        return empresa1;
    }

    public void setEmpresa1(Empresa empresa1) {
        this.empresa1 = empresa1;
    }

    public ClaseServicio getClaseServicio() {
        return claseServicio;
    }

    public void setClaseServicio(ClaseServicio claseServicio) {
        this.claseServicio = claseServicio;
    }

    public String getStatusCorrida() {
        return statusCorrida;
    }

    public void setStatusCorrida(String statusCorrida) {
        this.statusCorrida = statusCorrida;
    }

    public Integer getDiagramaAutobusId() {
        return diagramaAutobusId;
    }

    public void setDiagramaAutobusId(Integer diagramaAutobusId) {
        this.diagramaAutobusId = diagramaAutobusId;
    }

    public Division getDivision() {
        return division;
    }

    public void setDivision(Division division) {
        this.division = division;
    }

    public Boolean getPisoExtra() {
        return pisoExtra;
    }

    public void setPisoExtra(Boolean pisoExtra) {
        this.pisoExtra = pisoExtra;
    }

    public List<EsquemaTramo> getEsquemaTramoList() {
        if (this.esquemaTramoList != null) {
            List<EsquemaTramo> esquemaList = new ArrayList<EsquemaTramo>();

            for (EsquemaTramo ec : this.esquemaTramoList) {
                if (ec.getActivo() == Boolean.TRUE) {
                    esquemaList.add(ec);
                }
            }
            return esquemaList;
        }
        return null;

    }

    public void setEsquemaTramoList(List<EsquemaTramo> esquemaTramoList) {
        this.esquemaTramoList = esquemaTramoList;
    }

    public List<EsquemaAsiento> getEsquemaAsientoList() {
        List<EsquemaAsiento> esquemaList = new ArrayList<EsquemaAsiento>();
        for (EsquemaAsiento ec : this.esquemaAsientoList) {
            if (ec.getActivo() == Boolean.TRUE) {
                esquemaList.add(ec);
            }
        }
        return esquemaList;
    }

    public void setEsquemaAsientoList(List<EsquemaAsiento> esquemaAsientoList) {
        this.esquemaAsientoList = esquemaAsientoList;
    }

    public EsquemaCorrida getEsquemaCorridaRebote() {
        return esquemaCorridaRebote;
    }

    public void setEsquemaCorridaRebote(EsquemaCorrida esquemaCorridaRebote) {
        this.esquemaCorridaRebote = esquemaCorridaRebote;
    }

    public ClaseServicio getClaseServicio2() {
        return claseServicio2;
    }

    public void setClaseServicio2(ClaseServicio claseServicio2) {
        this.claseServicio2 = claseServicio2;
    }

    public RolOperativo getRolOperativo2() {
        return rolOperativo2;
    }

    public void setRolOperativo2(RolOperativo rolOperativo2) {
        this.rolOperativo2 = rolOperativo2;
    }

    public Integer getNumCorrida() {
        return numCorrida;
    }

    public void setNumCorrida(Integer numCorrida) {
        this.numCorrida = numCorrida;
    }
    
    public Integer getNumCorridaPisoExtra() {
        return numCorridaPisoExtra;
    }

    public void setNumCorridaPisoExtra(Integer numCorridaPisoExtra) {
        this.numCorridaPisoExtra = numCorridaPisoExtra;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (esquemacorridaId != null ? esquemacorridaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are
        // not set
        if (!(object instanceof EsquemaCorrida)) {
            return false;
        }
        EsquemaCorrida other = (EsquemaCorrida) object;
        if ((this.esquemacorridaId == null && other.esquemacorridaId != null) || (this.esquemacorridaId != null && !this.esquemacorridaId.equals(other.esquemacorridaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.test.EsquemaCorrida[esquemacorridaId=" + esquemacorridaId + "]";
    }
}
