/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 * 
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "ESQUEMA_TRAMO_SEQ", sequenceName = "ESQUEMA_TRAMO_SEQ", allocationSize = 1)
@Table(name = "ESQUEMA_TRAMO")
public class EsquemaTramo implements Serializable {

	private static final long serialVersionUID = 1L;
	@Id
	@Basic(optional = false)
	@Column(name = "ESQUEMATRAMO_ID")
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "ESQUEMA_TRAMO_SEQ")
	private Integer esquematramoId;
	@Column(name = "NUMSECUENCIA")
	private Short numsecuencia;
	@Column(name = "ACTIVO")
	private Boolean activo;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	@Column(name = "TIEMPOESTANCIA")
	@Temporal(javax.persistence.TemporalType.TIMESTAMP)
	private Date tiempoEstancia;
	@JoinColumn(name = "TRAMO_ID", referencedColumnName = "TRAMO_ID")
	@ManyToOne
	private Tramo tramo;
	@JoinColumn(name = "ESQUEMACORRIDA_ID", referencedColumnName = "ESQUEMACORRIDA_ID")
	@ManyToOne
	private EsquemaCorrida esquemaCorrida;
	@Column(name = "PLATAFORMA")
	private String plataforma;

	public Date getTiempoEstancia() {
		return tiempoEstancia;
	}

	public void setTiempoEstancia(Date tiempoEstancia) {
		this.tiempoEstancia = tiempoEstancia;
	}

	public EsquemaTramo() {
	}

	public EsquemaTramo(Integer esquematramoId) {
		this.esquematramoId = esquematramoId;
	}

	public Integer getEsquematramoId() {
		return esquematramoId;
	}

	public void setEsquematramoId(Integer esquematramoId) {
		this.esquematramoId = esquematramoId;
	}

	public Short getNumsecuencia() {
		return numsecuencia;
	}

	public void setNumsecuencia(Short numsecuencia) {
		this.numsecuencia = numsecuencia;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	public Tramo getTramo() {
		return tramo;
	}

	public void setTramo(Tramo tramo) {
		this.tramo = tramo;
	}

	public EsquemaCorrida getEsquemaCorrida() {
		return esquemaCorrida;
	}

	public void setEsquemaCorrida(EsquemaCorrida esquemaCorrida) {
		this.esquemaCorrida = esquemaCorrida;
	}

	public String getPlataforma() {
		return plataforma;
	}

	public void setPlataforma(String plataforma) {
		this.plataforma = plataforma;
	}

	@Override
	public int hashCode() {
		int hash = 0;
		hash += (esquematramoId != null ? esquematramoId.hashCode() : 0);
		return hash;
	}

	@Override
	public boolean equals(Object object) {
		// TODO: Warning - this method won't work in the case the id fields are
		// not set
		if (!(object instanceof EsquemaTramo)) {
			return false;
		}
		EsquemaTramo other = (EsquemaTramo) object;
		if ((this.esquematramoId == null && other.esquematramoId != null) || (this.esquematramoId != null && !this.esquematramoId.equals(other.esquematramoId))) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "com.rjconsultores.ventaboletos.entidad.test.EsquemaTramo[esquematramoId=" + esquematramoId + "]";
	}
}
