/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * 
 * @author Administrador
 */
@Entity
@Table(name = "ESTACION")
@SequenceGenerator(name = "ESTACION_SEQ", sequenceName = "ESTACION_SEQ", allocationSize = 1)
public class Estacion implements Serializable {

	public final static String CONEXION_SANTANDER = "S";
	public final static String CONEXION_BANORTE = "B";
	public final static String CONEXION_SW_MANUAL = "M";
	public final static String CONEXION_SW_PINPAD = "E";

	private static final long serialVersionUID = 1L;
	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "ESTACION_SEQ")
	@Column(name = "ESTACION_ID")
	private Integer estacionId;
	@Column(name = "NUMCAJA")
	private Long numcaja;
	@Column(name = "DESCESTACION")
	private String descestacion;
	@Column(name = "DESCMAC")
	private String descmac;
	@Column(name = "INDCONEXIONBANCARIA")
	private String conexionBancaria;
	@Column(name = "ACTIVO")
	private Boolean activo;
	@Column(name = "INDIMPRESIONPINPAD")
	private Boolean pinPadImpresoraPropia;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	@OneToOne
	@JoinColumn(name = "PUNTOVENTA_ID")
	private PuntoVenta puntoVenta;
	@OneToOne
	@JoinColumn(name = "USUARIOBANCARIO_ID")
	private UsuarioBancario usuarioBancario;
	@Column(name = "NOMEIMPRESSORA")
	private String nomeImpressora;
	@Column(name = "NOMEARQUIVOLAYOUT")
	private String nomeArquivoLayout;
	@Column(name = "NOMEIMPRESSORARELATORIO")
	private String nomeImpressoraRelatorio;

	public Estacion() {
	}

	public Estacion(Integer estacionId) {
		this.estacionId = estacionId;
	}

	public Integer getEstacionId() {
		return estacionId;
	}

	public void setEstacionId(Integer estacionId) {
		this.estacionId = estacionId;
	}

	public Long getNumcaja() {
		return numcaja;
	}

	public void setNumcaja(Long numcaja) {
		this.numcaja = numcaja;
	}

	public String getDescestacion() {
		return descestacion;
	}

	public void setDescestacion(String descestacion) {
		this.descestacion = descestacion;
	}

	public String getDescmac() {
		return descmac;
	}

	public void setDescmac(String descmac) {
		this.descmac = descmac;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	public PuntoVenta getPuntoVenta() {
		return puntoVenta;
	}

	public void setPuntoVenta(PuntoVenta puntoVenta) {
		this.puntoVenta = puntoVenta;
	}

	public UsuarioBancario getUsuarioBancario() {
		return usuarioBancario;
	}

	public void setUsuarioBancario(UsuarioBancario usuarioBancario) {
		this.usuarioBancario = usuarioBancario;
	}

	public String getConexionBancaria() {
		return conexionBancaria;
	}

	public void setConexionBancaria(String conexionBancaria) {
		this.conexionBancaria = conexionBancaria;
	}

	public Boolean getPinPadImpresoraPropia() {
		return pinPadImpresoraPropia;
	}

	public void setPinPadImpresoraPropia(Boolean pinPadImpresoraPropia) {
		this.pinPadImpresoraPropia = pinPadImpresoraPropia;
	}

	public String getNomeImpressora() {
		return nomeImpressora;
	}

	public void setNomeImpressora(String nomeImpressora) {
		this.nomeImpressora = nomeImpressora;
	}

	public String getNomeArquivoLayout() {
		return nomeArquivoLayout;
	}

	public void setNomeArquivoLayout(String nomeArquivoLayout) {
		this.nomeArquivoLayout = nomeArquivoLayout;
	}

	public String getNomeImpressoraRelatorio() {
		return nomeImpressoraRelatorio;
	}

	public void setNomeImpressoraRelatorio(String nomeImpressoraRelatorio) {
		this.nomeImpressoraRelatorio = nomeImpressoraRelatorio;
	}

	@Override
	public int hashCode() {
		int hash = 0;
		hash += (estacionId != null ? estacionId.hashCode() : 0);
		return hash;
	}

	@Override
	public boolean equals(Object object) {
		if (!(object instanceof Estacion)) {
			return false;
		}
		Estacion other = (Estacion) object;
		if ((this.estacionId == null && other.estacionId != null) || (this.estacionId != null && !this.estacionId.equals(other.estacionId))) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "com.rjconsultores.ventaboletos.entidad.Estacion[estacionId=" + estacionId + "]";
	}
}
