/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "PRODUCTO_SERVICIO_SEQ", sequenceName = "PRODUCTO_SERVICIO_SEQ", allocationSize = 1)
@Table(name = "PRODUCTO_SERVICIO")
public class ProductoServicio implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "PRODUCTO_SERVICIO_SEQ")
    @Basic(optional = false)
    @Column(name = "PRODUCTOSERVICIO_ID")
    private Integer productoservicioId;
    @Column(name = "DESCPRODUCTOSERVICIO")
    private String descproductoservicio;
    @Column(name = "INDTIPO")
    private String indtipo;
    @Column(name = "DESCIMPRESIONBOLETO")
    private String descImpresionBoleto;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @OneToOne
    @JoinColumn(name = "EMPRESA_ID")
    private Empresa empresa;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToMany(mappedBy = "productoServicio", cascade = CascadeType.ALL)
    private List<ProdRuta> prodRutaList;
    @OneToMany(mappedBy = "productoServicio", cascade = CascadeType.ALL)
    private List<ProdMarca> prodMarcaList;
    @OneToMany(mappedBy = "productoServicio", cascade = CascadeType.ALL)
    private List<ProdTipoptovta> prodTipoptovtaList;
    @OneToMany(mappedBy = "productoServicio", cascade = CascadeType.ALL)
    private List<ProdPuntoVenta> prodPuntoVentaList;
    @OneToMany(mappedBy = "productoServicio", cascade = CascadeType.ALL)
    private List<ProdFormaPago> prodFormaPagoList;
    @OneToMany(mappedBy = "productoServicio", cascade = CascadeType.ALL)
    private List<ProdMercado> prodMercadoList;
    @OneToMany(mappedBy = "productoServicio", cascade = CascadeType.ALL)
    private List<ProdVigencia> prodVigenciaList;
    @OneToMany(mappedBy = "productoServicio", cascade = CascadeType.ALL)
    private List<ProdClaseServicio> prodClaseServicioList;
    @OneToMany(mappedBy = "productoservicio", cascade = CascadeType.ALL)
    private List<ProdPrecio> prodPrecioList;

    public ProductoServicio() {
    }

    public ProductoServicio(Integer productoservicioId) {
        this.productoservicioId = productoservicioId;
    }

    public Integer getProductoservicioId() {
        return productoservicioId;
    }

    public void setProductoservicioId(Integer productoservicioId) {
        this.productoservicioId = productoservicioId;
    }

    public String getDescproductoservicio() {
        return descproductoservicio;
    }

    public void setDescproductoservicio(String descproductoservicio) {
        this.descproductoservicio = descproductoservicio;
    }

    public String getIndtipo() {
        return indtipo;
    }

    public void setIndtipo(String indtipo) {
        this.indtipo = indtipo;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public List<ProdClaseServicio> getProdClaseServicioList() {
        List<ProdClaseServicio> poList = new ArrayList<ProdClaseServicio>();
        for (ProdClaseServicio po : this.prodClaseServicioList) {
            if (po.getActivo() == Boolean.TRUE) {
                poList.add(po);
            }
        }
        return poList;
    }

    public void setProdClaseServicioList(List<ProdClaseServicio> prodClaseServicioList) {
        this.prodClaseServicioList = prodClaseServicioList;
    }

    public List<ProdFormaPago> getProdFormaPagoList() {
        List<ProdFormaPago> poList = new ArrayList<ProdFormaPago>();
        for (ProdFormaPago po : this.prodFormaPagoList) {
            if (po.getActivo() == Boolean.TRUE) {
                poList.add(po);
            }
        }
        return poList;
    }

    public void setProdFormaPagoList(List<ProdFormaPago> prodFormaPagoList) {
        this.prodFormaPagoList = prodFormaPagoList;
    }

    public List<ProdMarca> getProdMarcaList() {
        List<ProdMarca> poList = new ArrayList<ProdMarca>();
        for (ProdMarca po : this.prodMarcaList) {
            if (po.getActivo() == Boolean.TRUE) {
                poList.add(po);
            }
        }
        return poList;
    }

    public void setProdMarcaList(List<ProdMarca> prodMarcaList) {
        this.prodMarcaList = prodMarcaList;
    }

    public List<ProdMercado> getProdMercadoList() {

        List<ProdMercado> poList = new ArrayList<ProdMercado>();
        for (ProdMercado po : this.prodMercadoList) {
            if (po.getActivo() == Boolean.TRUE) {
                poList.add(po);
            }
        }
        return poList;
    }

    public void setProdMercadoList(List<ProdMercado> prodMercadoList) {
        this.prodMercadoList = prodMercadoList;
    }

    public List<ProdPuntoVenta> getProdPuntoVentaList() {

        List<ProdPuntoVenta> poList = new ArrayList<ProdPuntoVenta>();
        for (ProdPuntoVenta po : this.prodPuntoVentaList) {
            if (po.getActivo() == Boolean.TRUE) {
                poList.add(po);
            }
        }
        return poList;
    }

    public void setProdPuntoVentaList(List<ProdPuntoVenta> prodPuntoVentaList) {
        this.prodPuntoVentaList = prodPuntoVentaList;
    }

    public List<ProdRuta> getProdRutaList() {
        List<ProdRuta> poList = new ArrayList<ProdRuta>();
        for (ProdRuta po : this.prodRutaList) {
            if (po.getActivo() == Boolean.TRUE) {
                poList.add(po);
            }
        }
        return poList;
    }

    public void setProdRutaList(List<ProdRuta> prodRutaList) {
        this.prodRutaList = prodRutaList;
    }

    public List<ProdTipoptovta> getProdTipoptovtaList() {
        List<ProdTipoptovta> poList = new ArrayList<ProdTipoptovta>();
        for (ProdTipoptovta po : this.prodTipoptovtaList) {
            if (po.getActivo() == Boolean.TRUE) {
                poList.add(po);
            }
        }
        return poList;
    }

    public void setProdTipoptovtaList(List<ProdTipoptovta> prodTipoptovtaList) {
        this.prodTipoptovtaList = prodTipoptovtaList;
    }

    public List<ProdVigencia> getProdVigenciaList() {
        List<ProdVigencia> poList = new ArrayList<ProdVigencia>();
        for (ProdVigencia po : this.prodVigenciaList) {
            if (po.getActivo() == Boolean.TRUE) {
                poList.add(po);
            }
        }
        return poList;
    }

    public void setProdVigenciaList(List<ProdVigencia> prodVigenciaList) {
        this.prodVigenciaList = prodVigenciaList;
    }

    public List<ProdPrecio> getProdPrecioList() {
        List<ProdPrecio> ppList = new ArrayList<ProdPrecio>();
        for (ProdPrecio pp : this.prodPrecioList) {
            if (pp.getActivo() == Boolean.TRUE) {
                ppList.add(pp);
            }
        }
        return ppList;
    }

    public void setProdPrecioList(List<ProdPrecio> prodPrecioList) {
        this.prodPrecioList = prodPrecioList;
    }

    public String getDescImpresionBoleto() {
        return descImpresionBoleto;
    }

    public void setDescImpresionBoleto(String descImpresionBoleto) {
        this.descImpresionBoleto = descImpresionBoleto;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (productoservicioId != null ? productoservicioId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ProductoServicio)) {
            return false;
        }
        ProductoServicio other = (ProductoServicio) object;
        if ((this.productoservicioId == null && other.productoservicioId != null) || (this.productoservicioId != null && !this.productoservicioId.equals(other.productoservicioId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.utilerias.ProductoServicio[productoservicioId=" + productoservicioId + "]";
    }
}
