/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafael
 */
@Entity
@Table(name = "PTOVTA_DIVERSOS")
@NamedQueries({
    @NamedQuery(name = "PtovtaDiversos.findAll", query = "SELECT p FROM PtovtaDiversos p")})
public class PtovtaDiversos implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "ID")
    private Integer id;
    
    @Column(name = "RESPON_ALUGUEL")
    private String responAluguel;
    
    @Column(name = "RESPON_TELEFONE")
    private String responTelefone;
   
    @Column(name = "RESPON_ENERGIA")
    private String responEnergia;
   
    @Column(name = "POSICAO")
    private String posicao;
    
    @Basic(optional = false)
    @Column(name = "ACTIVO")
    private Boolean activo;
   
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
   
    @Column(name = "USUARIO_ID")
    private int usuarioId;
    
    @OneToMany(mappedBy = "diversosId")
    private List<PtovtaInformacao> ptovtaInformacaoList;
    
    @JoinColumn(name = "PUNTOVENTA_ID", referencedColumnName = "PUNTOVENTA_ID")
    @ManyToOne
    private PuntoVenta puntoventaId;

    public PtovtaDiversos() {
    }

    public PtovtaDiversos(Integer id) {
        this.id = id;
    }

    public PtovtaDiversos(Integer id, String responAluguel, String responTelefone, String responEnergia, String posicao, Boolean activo, Date fecmodif, int usuarioId) {
        this.id = id;
        this.responAluguel = responAluguel;
        this.responTelefone = responTelefone;
        this.responEnergia = responEnergia;
        this.posicao = posicao;
        this.activo = activo;
        this.fecmodif = fecmodif;
        this.usuarioId = usuarioId;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getResponAluguel() {
        return responAluguel;
    }

    public void setResponAluguel(String responAluguel) {
        this.responAluguel = responAluguel;
    }

    public String getResponTelefone() {
        return responTelefone;
    }

    public void setResponTelefone(String responTelefone) {
        this.responTelefone = responTelefone;
    }

    public String getResponEnergia() {
        return responEnergia;
    }

    public void setResponEnergia(String responEnergia) {
        this.responEnergia = responEnergia;
    }

    public String getPosicao() {
        return posicao;
    }

    public void setPosicao(String posicao) {
        this.posicao = posicao;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public int getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(int usuarioId) {
        this.usuarioId = usuarioId;
    }

   

    public PuntoVenta getPuntoventaId() {
        return puntoventaId;
    }

    public void setPuntoventaId(PuntoVenta puntoventaId) {
        this.puntoventaId = puntoventaId;
    }

    public List<PtovtaInformacao> getPtovtaInformacaoList() {
        return ptovtaInformacaoList;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PtovtaDiversos)) {
            return false;
        }
        PtovtaDiversos other = (PtovtaDiversos) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.PtovtaDiversos[ id=" + id + " ]";
    }
    
}
