/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service;

import java.util.Date;
import java.util.List;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.entidad.EsquemaCorrida;
import com.rjconsultores.ventaboletos.entidad.Parada;

/**
 *
 * @author rodrigo
 */
public interface CorridaService extends GenericService<Corrida, Corrida.Id> {

    public void generarCorrida(Date dataGeracao, List<EsquemaCorrida> lsEsquemaCorrida);

    /**
     * Genera las corridas de acuerdo con el parametro de cant dias.
     * 
     * 
     * @return - Si fue generado exitosamente o no
     */
    public boolean generarCorridaAutomatica();

    public List<Corrida> buscarPorAutobusCorridasFuturas(DiagramaAutobus diagramaAutobus);

    public List<Corrida> buscarPorRolOperativoCorridasFuturas(DiagramaAutobus diagramaAutobus);

    public List<Corrida> buscarPorFecCorrida(Date value);

    public List<Corrida> buscarPorId(Integer idCorrida);

    public List<Corrida> buscarFiltro(Parada ori, Parada des, Date hora, ClaseServicio cs);
    
    /**
     * Regresa la fecha final para el perodo de generacin automatica de corridas.
     * 
     *  
     * @return
     */
    public Date calcularDataFinalGeneracionCorrida();
    
    public boolean generarCorridaAutomatica(Date dataDe, Date dataAte);
    
    public List<Corrida> buscarDistinct(Parada ori, Parada des, Date horaSalidaInicio, Date horaSalidaFin, ClaseServicio cs, Integer corridaId);
}
