/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service;

import java.util.List;

import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Plaza;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.Tarifa;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;

/**
 *
 * @author rodrigo
 */
public interface TarifaService extends GenericService<Tarifa, Integer> {

    public List<Tarifa> pesquisar(Marca marca, Parada origem, Parada destino, Moneda moneda,ClaseServicio claseServicio, VigenciaTarifa vigenciaTarifa,
            Categoria categoria, TipoPuntoVenta tipoPuntoVenta);

    /**
     * Mtodo usado para checar se uma tarifa j est cadastrada no sistema.
     * 
     * Uma tarifa  considerada nica de acordo a marca, tramo, moneda, claseServicio, vigenciaTarifa, ruta e orgaoConcedente
     * 
     * @param marca
     * @param tramo
     * @param moneda
     * @param claseServicio
     * @param vigenciaTarifa
     * @param ruta
     * @param orgaoConcedente
     * @return
     */
    public boolean existe(Marca marca, Tramo tramo, Moneda moneda,ClaseServicio claseServicio, VigenciaTarifa vigenciaTarifa, Ruta ruta, OrgaoConcedente orgaoConcedente);
    
    public Tarifa buscar(Tramo tramo, Marca marca, ClaseServicio claseServicio,VigenciaTarifa vigenciaTarifa, Moneda moneda, Ruta ruta);

    public List<Tarifa> buscarPorVigencia(VigenciaTarifa vigencia);

    public Boolean podeAlterarTarifaMinima(Tarifa tarifa, Marca marca, Parada origem,Parada destino, ClaseServicio claseServicio, Plaza plaza, Moneda moneda);

    public List<Tarifa> buscarExisteVigencia(VigenciaTarifa vigenciaTarifa);

    public Boolean generarTarifas(VigenciaTarifa vigencia, Marca marca);

    public boolean buscarTarifaExisteTramo(Tramo tramo);
}
