package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.AliasServicoDAO;
import com.rjconsultores.ventaboletos.entidad.AliasServico;
import com.rjconsultores.ventaboletos.service.AliasServicoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("aliasServicoService")
public class AliasServicoServiceImpl implements AliasServicoService {

	@Autowired
	private AliasServicoDAO aliasServicoDAO;

	public List<AliasServico> obtenerTodos() {
		return aliasServicoDAO.obtenerTodos();
	}

	public AliasServico obtenerID(Integer id) {
		return aliasServicoDAO.obtenerID(id);
	}

	@Transactional
	public AliasServico suscribir(AliasServico entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return aliasServicoDAO.suscribir(entidad);
	}

	@Transactional
	public AliasServico actualizacion(AliasServico entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return aliasServicoDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(AliasServico entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		aliasServicoDAO.actualizacion(entidad);
	}
}
