package com.rjconsultores.ventaboletos.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConexionDAO;
import com.rjconsultores.ventaboletos.service.ConexionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.vo.conexion.ConexionVO;

@Service("conexionService")
public class ConexionServiceImpl implements ConexionService {

	@Autowired
	private ConexionDAO conexionDAO;

	@Override
	@Transactional
	public void gerarConexiones() {
		conexionDAO.generarConexiones(UsuarioLogado.getUsuarioLogado().getUsuarioId());
	}

	@Override
	public List<ConexionVO> buscarConexiones(Integer origenId, Integer destinoId) {
		return conexionDAO.buscarConexiones(origenId, destinoId);
	}

}
