package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConfRestricaoCanalVentaDAO;
import com.rjconsultores.ventaboletos.entidad.ConfRestricaoCanalVenta;
import com.rjconsultores.ventaboletos.service.ConfRestricaoCanalVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("confRestricaoCanalVentaService")
public class ConfRestricaoCanalVentaServiceImpl implements ConfRestricaoCanalVentaService {
	@Autowired
	private ConfRestricaoCanalVentaDAO confRestricaoCanalVentaDAO;

	public List<ConfRestricaoCanalVenta> obtenerTodos() {
		return confRestricaoCanalVentaDAO.obtenerTodos();
	}

	public ConfRestricaoCanalVenta obtenerID(Integer id) {
		return confRestricaoCanalVentaDAO.obtenerID(id);
	}

	@Transactional
	public ConfRestricaoCanalVenta suscribir(ConfRestricaoCanalVenta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoCanalVentaDAO.suscribir(entidad);
	}

	@Transactional
	public ConfRestricaoCanalVenta actualizacion(ConfRestricaoCanalVenta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoCanalVentaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(ConfRestricaoCanalVenta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		confRestricaoCanalVentaDAO.actualizacion(entidad);
	}
}
