/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ConstanteDAO;
import com.rjconsultores.ventaboletos.entidad.Constante;
import com.rjconsultores.ventaboletos.service.ConstanteService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("constanteService")
public class ConstanteServiceImpl implements ConstanteService {

    @Autowired
    private ConstanteDAO constanteDAO;

    public List<Constante> obtenerTodos() {
        return constanteDAO.obtenerTodos();
    }

    public Constante obtenerID(Integer id) {
        return constanteDAO.obtenerID(id);
    }

    @Transactional
    public Constante suscribir(Constante entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return constanteDAO.suscribir(entidad);
    }

    @Transactional
    public Constante actualizacion(Constante entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return constanteDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Constante entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        constanteDAO.actualizacion(entidad);
    }

    public Constante buscarPorNomeConstante(String nomeConstante) {
        return constanteDAO.buscarPorNomeConstante(nomeConstante);
    }

    public List<Constante> buscar(String nombconstante) {
        return constanteDAO.buscar(nombconstante);
    }
    
    @Override
    public String buscarNombreAmbiente(){
    	Constante constante = constanteDAO.buscarPorNomeConstante("NOMBRE_AMBIENTE");
    	if (constante == null){
    		return "";
    	}
    	
    	return constante.getValorconstante();
    }
}
