package com.rjconsultores.ventaboletos.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CorridaTramoDAO;
import com.rjconsultores.ventaboletos.entidad.CorridaTramo;
import com.rjconsultores.ventaboletos.service.CorridaTramoService;

@Service("corridaTramoService")
public class CorridaTramoServiceImpl implements CorridaTramoService {

	@Autowired
    private CorridaTramoDAO corridaTramoDAO;
	
	@Override
	public List<CorridaTramo> obtenerTodos() {
		return corridaTramoDAO.obtenerTodos();
	}

	@Override
	public CorridaTramo obtenerID(Integer id) {
		return corridaTramoDAO.obtenerID(id);
	}

	@Override
	public CorridaTramo suscribir(CorridaTramo entidad) {
		return corridaTramoDAO.suscribir(entidad);
	}

	@Override
	public CorridaTramo actualizacion(CorridaTramo entidad) {
		return corridaTramoDAO.actualizacion(entidad);
	}

	@Override
	public void borrar(CorridaTramo entidad) {
		corridaTramoDAO.borrar(entidad);
	}

	@Override
	public List<CorridaTramo> obtenerTramoTarjetaEmitida() {
		return corridaTramoDAO.obtenerTramoTarjetaEmitida();
	}
}
