package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.OrgaoConcedenteDAO;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.service.OrgaoConcedenteService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("orgaoConcedenteService")
public class OrgaoConcedenteServiceImpl implements OrgaoConcedenteService {

	@Autowired
	private OrgaoConcedenteDAO orgaoConcedenteDAO;

	public List<OrgaoConcedente> obtenerTodos() {
		return orgaoConcedenteDAO.obtenerTodos();
	}

	public OrgaoConcedente obtenerID(Integer id) {
		return orgaoConcedenteDAO.obtenerID(id);
	}

	@Transactional
	public OrgaoConcedente suscribir(OrgaoConcedente entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return orgaoConcedenteDAO.suscribir(entidad);
	}

	@Transactional
	public OrgaoConcedente actualizacion(OrgaoConcedente entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return orgaoConcedenteDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(OrgaoConcedente entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		orgaoConcedenteDAO.actualizacion(entidad);
	}

	public List<OrgaoConcedente> buscar(String desc) {
		return orgaoConcedenteDAO.buscar(desc);
	}
}
