/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingAnticipacionDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingAnticipacion;
import com.rjconsultores.ventaboletos.service.PricingAnticipacionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Desenvolvimento
 */
@Service("pricingAnticipacionService")
public class PricingAnticipacionServiceImpl implements PricingAnticipacionService {

    @Autowired
    private PricingAnticipacionDAO pricingAnticipacionDAO;

    public List<PricingAnticipacion> obtenerTodos() {
        return pricingAnticipacionDAO.obtenerTodos();
    }

    public PricingAnticipacion obtenerID(Integer id) {
        return pricingAnticipacionDAO.obtenerID(id);
    }

    @Transactional
    public PricingAnticipacion suscribir(PricingAnticipacion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingAnticipacionDAO.suscribir(entidad);
    }

    @Transactional
    public PricingAnticipacion actualizacion(PricingAnticipacion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingAnticipacionDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingAnticipacion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pricingAnticipacionDAO.actualizacion(entidad);
    }

    public List<PricingAnticipacion> obtenerPorPricing(Pricing pricing) {
        return pricingAnticipacionDAO.obtenerPorPricing(pricing);
    }
}
