/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingOcupacionDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingOcupacion;
import com.rjconsultores.ventaboletos.service.PricingOcupacionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("pricingOcupacionService")
public class PricingOcupacionServiceImpl implements PricingOcupacionService {

    @Autowired
    private PricingOcupacionDAO pricingOcupacionDAO;

    public List<PricingOcupacion> obtenerTodos() {
        return pricingOcupacionDAO.obtenerTodos();
    }

    public PricingOcupacion obtenerID(Integer id) {
        return pricingOcupacionDAO.obtenerID(id);
    }

    @Transactional
    public PricingOcupacion suscribir(PricingOcupacion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingOcupacionDAO.suscribir(entidad);
    }

    @Transactional
    public PricingOcupacion actualizacion(PricingOcupacion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingOcupacionDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingOcupacion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pricingOcupacionDAO.actualizacion(entidad);
    }

    public Boolean podeSalvar(Pricing pricing, BigDecimal min, BigDecimal max) {
        return pricingOcupacionDAO.podeSalvar(pricing, min, max);
    }

    public List<PricingOcupacion> obtenerPorPricing(Pricing pricing) {
        return pricingOcupacionDAO.podeSalvar(pricing);
    }
}
