/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PtovtaAgenciaBancariaDAO;
import com.rjconsultores.ventaboletos.entidad.ProdVigencia;
import com.rjconsultores.ventaboletos.entidad.PtovtaAgenciaBancaria;
import com.rjconsultores.ventaboletos.service.ProdVigenciaService;
import com.rjconsultores.ventaboletos.service.PtovtaAgenciaBancariaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Desenvolvimento
 */
@Service("ptovtaAgenciaBancariaService")
public class PtovtaAgenciaBancariaServiceImpl implements PtovtaAgenciaBancariaService {

    @Autowired
    private PtovtaAgenciaBancariaDAO ptovtaBancoDAO;

    public List<PtovtaAgenciaBancaria> obtenerTodos() {
        return ptovtaBancoDAO.obtenerTodos();
    }

    public PtovtaAgenciaBancaria obtenerID(Integer id) {
        return ptovtaBancoDAO.obtenerID(id);
    }

    @Transactional
    public PtovtaAgenciaBancaria suscribir(PtovtaAgenciaBancaria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaBancoDAO.suscribir(entidad);
    }

    @Transactional
    public PtovtaAgenciaBancaria actualizacion(PtovtaAgenciaBancaria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaBancoDAO.actualizacion(entidad);
    }

   
    @Transactional
    public void borrar(PtovtaAgenciaBancaria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        ptovtaBancoDAO.actualizacion(entidad);
    }
    
    
    public List<PtovtaAgenciaBancaria> buscar(String numagencia) {
        return ptovtaBancoDAO.buscar(numagencia);
    }

    
}
