/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PtovtaBancoDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaBanco;
import com.rjconsultores.ventaboletos.service.PtovtaBancoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Desenvolvimento
 */
@Service("ptovtaBancoService")
public class PtovtaBancoServiceImpl implements PtovtaBancoService {

    @Autowired
    private PtovtaBancoDAO ptovtaBancoDAO;

    public List<PtovtaBanco> obtenerTodos() {
        return ptovtaBancoDAO.obtenerTodos();
    }

    public PtovtaBanco obtenerID(Integer id) {
        return ptovtaBancoDAO.obtenerID(id);
    }

    @Transactional
    public PtovtaBanco suscribir(PtovtaBanco entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaBancoDAO.suscribir(entidad);
    }

    @Transactional
    public PtovtaBanco actualizacion(PtovtaBanco entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaBancoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PtovtaBanco entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        ptovtaBancoDAO.actualizacion(entidad);
    }

    public List<PtovtaBanco> buscar(String nome) {
        return ptovtaBancoDAO.buscar(nome);
    }

    
}
