/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;


import com.rjconsultores.ventaboletos.dao.PtovtaComissaoDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaComissao;
import com.rjconsultores.ventaboletos.service.PtovtaComissaoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Desenvolvimento
 */
@Service("ptovtaComissaoService")
public class PtovtaComissaoServiceImpl implements PtovtaComissaoService {

    @Autowired
    private PtovtaComissaoDAO ptovtaComissaoDAO;

    public List<PtovtaComissao> obtenerTodos() {
        return ptovtaComissaoDAO.obtenerTodos();
    }

    public PtovtaComissao obtenerID(Integer id) {
        return ptovtaComissaoDAO.obtenerID(id);
    }

    @Transactional
    public PtovtaComissao suscribir(PtovtaComissao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaComissaoDAO.suscribir(entidad);
    }

    @Transactional
    public PtovtaComissao actualizacion(PtovtaComissao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaComissaoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PtovtaComissao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        ptovtaComissaoDAO.actualizacion(entidad);
    }

    public List<PtovtaComissao> buscar(int id) {
        return ptovtaComissaoDAO.buscar(id);
    }

    
}
