/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;


import com.rjconsultores.ventaboletos.dao.PtovtaInformacaoDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaInformacao;
import com.rjconsultores.ventaboletos.service.PtovtaInformacaoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Desenvolvimento
 */
@Service("ptovtaInformacaoService")
public class PtovtaInformacaoServiceImpl implements PtovtaInformacaoService {

    @Autowired
    private PtovtaInformacaoDAO ptovtaInformacaoDAO;

    public List<PtovtaInformacao> obtenerTodos() {
        return ptovtaInformacaoDAO.obtenerTodos();
    }

    public PtovtaInformacao obtenerID(Integer id) {
        return ptovtaInformacaoDAO.obtenerID(id);
    }

    @Transactional
    public PtovtaInformacao suscribir(PtovtaInformacao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaInformacaoDAO.suscribir(entidad);
    }

    @Transactional
    public PtovtaInformacao actualizacion(PtovtaInformacao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaInformacaoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PtovtaInformacao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        ptovtaInformacaoDAO.actualizacion(entidad);
    }

    public List<PtovtaInformacao> buscar(int id) {
        return ptovtaInformacaoDAO.buscar(id);
    }

    
}
