/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;


import com.rjconsultores.ventaboletos.dao.PtovtaPercentualDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaPercentual;
import com.rjconsultores.ventaboletos.service.PtovtaPercentualService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Desenvolvimento
 */
@Service("ptovtaPercentualService")
public class PtovtaPercentualServiceImpl implements PtovtaPercentualService {

    @Autowired
    private PtovtaPercentualDAO ptovtaPercentualDAO;

    public List<PtovtaPercentual> obtenerTodos() {
        return ptovtaPercentualDAO.obtenerTodos();
    }

    public PtovtaPercentual obtenerID(Integer id) {
        return ptovtaPercentualDAO.obtenerID(id);
    }

    @Transactional
    public PtovtaPercentual suscribir(PtovtaPercentual entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaPercentualDAO.suscribir(entidad);
    }

    @Transactional
    public PtovtaPercentual actualizacion(PtovtaPercentual entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaPercentualDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PtovtaPercentual entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        ptovtaPercentualDAO.actualizacion(entidad);
    }

    public List<PtovtaPercentual> buscar(int id) {
        return ptovtaPercentualDAO.buscar(id);
    }

    
}
