/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;


import com.rjconsultores.ventaboletos.dao.PtovtaTipoPercentualDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaTipoPercentual;
import com.rjconsultores.ventaboletos.service.PtovtaTipoPercentualService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Desenvolvimento
 */
@Service("ptovtaTipoPercentualService")
public class PtovtaTipoPercentualServiceImpl implements PtovtaTipoPercentualService {

    @Autowired
    private PtovtaTipoPercentualDAO ptovtaTipoPercentualDAO;

    public List<PtovtaTipoPercentual> obtenerTodos() {
        return ptovtaTipoPercentualDAO.obtenerTodos();
    }

    public PtovtaTipoPercentual obtenerID(Integer id) {
        return ptovtaTipoPercentualDAO.obtenerID(id);
    }

    @Transactional
    public PtovtaTipoPercentual suscribir(PtovtaTipoPercentual entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaTipoPercentualDAO.suscribir(entidad);
    }

    @Transactional
    public PtovtaTipoPercentual actualizacion(PtovtaTipoPercentual entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ptovtaTipoPercentualDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PtovtaTipoPercentual entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        ptovtaTipoPercentualDAO.actualizacion(entidad);
    }

    public List<PtovtaTipoPercentual> buscar(int id) {
        return ptovtaTipoPercentualDAO.buscar(id);
    }

    
}
