/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PuntoVentaDAO;
import com.rjconsultores.ventaboletos.entidad.FormaPagoDet;
import com.rjconsultores.ventaboletos.entidad.PtovtaEmpresa;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.PtovtaEmpresaService;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("puntoVentaService")
public class PuntoVentaServiceImpl implements PuntoVentaService {

    @Autowired
    private PuntoVentaDAO puntoVentaDAO;
    @Autowired
    private PtovtaEmpresaService ptoVtaService;

    public List<PuntoVenta> obtenerTodos() {
        return puntoVentaDAO.obtenerTodos();
    }

    public PuntoVenta obtenerID(Integer id) {
        return puntoVentaDAO.obtenerID(id);
    }

    @Transactional
    public PuntoVenta suscribir(PuntoVenta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return puntoVentaDAO.suscribir(entidad);
    }

    @Transactional
    public PuntoVenta actualizacion(PuntoVenta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return puntoVentaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PuntoVenta entidad) {

        for (FormaPagoDet forma : entidad.getLsFormaPagoDet()) {
            forma.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            forma.setFecmodif(Calendar.getInstance().getTime());
            forma.setActivo(Boolean.FALSE);
        }

        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        puntoVentaDAO.actualizacion(entidad);
    }

    public List<PuntoVenta> buscaLike(String strEstacion) {
        return puntoVentaDAO.buscaLike(strEstacion);
    }

    public List<PuntoVenta> buscar(PuntoVenta puntoVenta) {
        return puntoVentaDAO.busca(puntoVenta);
    }
}
